; ..............................................................................
;    File   AUDIO.s
; ..............................................................................

		.equ AUDIONumTaps, 31

; ..............................................................................
; Allocate and initialize filter taps

		.section .AUDIOconst, code
		.align 64

AUDIOTaps:
.hword 	0xFFE4,	0x0009,	0x0065,	0x00D6,	0x0107,	0x009A,	0xFF61,	0xFDA2,	0xFC34
.hword 	0xFC3E,	0xFEC5,	0x0415,	0x0B6E,	0x1315,	0x18E0,	0x1B09,	0x18E0,	0x1315
.hword 	0x0B6E,	0x0415,	0xFEC5,	0xFC3E,	0xFC34,	0xFDA2,	0xFF61,	0x009A,	0x0107
.hword 	0x00D6,	0x0065,	0x0009,	0xFFE4

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 64

AUDIODelay:
		.space AUDIONumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _AUDIOFilter

_AUDIOFilter:
.hword AUDIONumTaps
.hword psvoffset(AUDIOTaps)
.hword psvoffset(AUDIOTaps)+AUDIONumTaps*2-1
.hword psvpage(AUDIOTaps)
.hword AUDIODelay
.hword AUDIODelay+AUDIONumTaps*2-1
.hword AUDIODelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_AUDIOFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_AUDIOFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_AUDIOFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
