; ..............................................................................
;    File   AUDIO_CW.s
; ..............................................................................

		.equ AUDIO_CWNumTaps, 31

; ..............................................................................
; Allocate and initialize filter taps

		.section .AUDIO_CWconst, code
		.align 64

AUDIO_CWTaps:
.hword 	0xFFC9,	0xFF76,	0xFF11,	0xFEAF,	0xFE72,	0xFE83,	0xFF06,	0x0016,	0x01BF
.hword 	0x03F2,	0x0686,	0x093F,	0x0BD0,	0x0DEC,	0x0F4F,	0x0FCB,	0x0F4F,	0x0DEC
.hword 	0x0BD0,	0x093F,	0x0686,	0x03F2,	0x01BF,	0x0016,	0xFF06,	0xFE83,	0xFE72
.hword 	0xFEAF,	0xFF11,	0xFF76,	0xFFC9

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 64

AUDIO_CWDelay:
		.space AUDIO_CWNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _AUDIO_CWFilter

_AUDIO_CWFilter:
.hword AUDIO_CWNumTaps
.hword psvoffset(AUDIO_CWTaps)
.hword psvoffset(AUDIO_CWTaps)+AUDIO_CWNumTaps*2-1
.hword psvpage(AUDIO_CWTaps)
.hword AUDIO_CWDelay
.hword AUDIO_CWDelay+AUDIO_CWNumTaps*2-1
.hword AUDIO_CWDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_AUDIO_CWFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_AUDIO_CWFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_AUDIO_CWFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
