; ..............................................................................
;    File   AUDIO_SSB.s
; ..............................................................................

		.equ AUDIO_SSBNumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .AUDIO_SSBconst, code
		.align 256

AUDIO_SSBTaps:
.hword  0x001E, 0xFFEF, 0xFF98, 0xFF25, 0xFEB1, 0xFE64, 0xFE6F, 0xFF02, 0x0037
.hword  0x0215, 0x047C, 0x072F, 0x09D9, 0x0C1B, 0x0D9D, 0x0E25, 0x0D9D, 0x0C1B
.hword  0x09D9, 0x072F, 0x047C, 0x0215, 0x0037, 0xFF02, 0xFE6F, 0xFE64, 0xFEB1
.hword  0xFF25, 0xFF98, 0xFFEF, 0x001E

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

AUDIO_SSBDelay:
		.space AUDIO_SSBNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _AUDIO_SSBFilter

_AUDIO_SSBFilter:
.hword AUDIO_SSBNumTaps
.hword psvoffset(AUDIO_SSBTaps)
.hword psvoffset(AUDIO_SSBTaps)+AUDIO_SSBNumTaps*2-1
.hword psvpage(AUDIO_SSBTaps)
.hword AUDIO_SSBDelay
.hword AUDIO_SSBDelay+AUDIO_SSBNumTaps*2-1
.hword AUDIO_SSBDelay

; ..............................................................................
;    File   AUDIO_CW.s
; ..............................................................................

		.equ AUDIO_CWNumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .AUDIO_CWconst, code
		.align 256

AUDIO_CWTaps:
.hword  0xFF86, 0xFFB6, 0x0000, 0x0066, 0x00E8, 0x0185, 0x0237, 0x02F8, 0x03C3
.hword  0x048C, 0x054B, 0x05F8, 0x0689, 0x06F5, 0x0739, 0x0751, 0x0739, 0x06F5
.hword  0x0689, 0x05F8, 0x054B, 0x048C, 0x03C3, 0x02F8, 0x0237, 0x0185, 0x00E8
.hword  0x0066, 0x0000, 0xFFB6, 0xFF86

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _AUDIO_CWFilter

_AUDIO_CWFilter:
.hword AUDIO_CWNumTaps
.hword psvoffset(AUDIO_CWTaps)
.hword psvoffset(AUDIO_CWTaps)+AUDIO_CWNumTaps*2-1
.hword psvpage(AUDIO_CWTaps)
.hword AUDIO_SSBDelay
.hword AUDIO_SSBDelay+AUDIO_CWNumTaps*2-1
.hword AUDIO_SSBDelay
