#include <stdio.h>

#include "FIR_Filter.h"
#include "BPF_500HZ.h"

#define NUM_SAMPLES 150
#define NUM_BLOCKS 10
#define NUM_SAMPLES_PER_BLOCK (NUM_SAMPLES-1)/NUM_BLOCKS+1

int main (int argc, char * argv[])
{
   FILE *pOutFile;
   int  inSamples[NUM_SAMPLES_PER_BLOCK], outSamples[NUM_SAMPLES_PER_BLOCK];
   int  i, j;


   pOutFile = fopen("BPF_500HZ_impresponse.dat", "wt");
   if( pOutFile == NULL )
		abort();

   FIRDelayInit( &BPF_500HZFilter );

   inSamples[0] = 0x7FFF;
   FIR( 1, &outSamples[0], &inSamples[0], &BPF_500HZFilter );

   fprintf( pOutFile, "%g\n", outSamples[0]/32768. );

   for( i=0; i < NUM_SAMPLES_PER_BLOCK; i++ )
		inSamples[i] = 0;

   for( i=0; i < NUM_BLOCKS; i++ )
   {
   FIR( NUM_SAMPLES_PER_BLOCK, &outSamples[0], &inSamples[0], &BPF_500HZFilter );
		for( j=0; j < NUM_SAMPLES_PER_BLOCK; j++ )
			 fprintf( pOutFile, "%g\n", outSamples[j]/32768. );
   }

   fclose(pOutFile);
   return 0;
}

