; ..............................................................................
;    File   BPF_700HZ.s
; ..............................................................................

		.equ BPF_700HZNumTaps, 151

; ..............................................................................
; Allocate and initialize filter taps

		.section .BPF_700HZconst, code
		.align 512

BPF_700HZTaps:
.hword 	0x009E,	0x00A8,	0x00A2,	0x008C,	0x0065,	0x0032,	0xFFF8,	0xFFBA,	0xFF7F
.hword 	0xFF4E,	0xFF2D,	0xFF1E,	0xFF24,	0xFF3F,	0xFF6A,	0xFFA3,	0xFFE2,	0x0020
.hword 	0x0057,	0x0083,	0x009D,	0x00A5,	0x009C,	0x0084,	0x0063,	0x003E,	0x001C
.hword 	0x0002,	0xFFF7,	0xFFF9,	0x0009,	0x0025,	0x0045,	0x0063,	0x0077,	0x0079
.hword 	0x0064,	0x0035,	0xFFEE,	0xFF92,	0xFF2A,	0xFEC3,	0xFE69,	0xFE2A,	0xFE13
.hword 	0xFE2E,	0xFE7D,	0xFF00,	0xFFB0,	0x007E,	0x015A,	0x022E,	0x02E1,	0x0360
.hword 	0x0399,	0x037F,	0x030E,	0x024C,	0x0145,	0x000E,	0xFEC4,	0xFD83,	0xFC6C
.hword 	0xFB9A,	0xFB26,	0xFB1E,	0xFB87,	0xFC5A,	0xFD87,	0xFEF4,	0x0080,	0x0209
.hword 	0x0368,	0x047E,	0x0530,	0x056E,	0x0530,	0x047E,	0x0368,	0x0209,	0x0080
.hword 	0xFEF4,	0xFD87,	0xFC5A,	0xFB87,	0xFB1E,	0xFB26,	0xFB9A,	0xFC6C,	0xFD83
.hword 	0xFEC4,	0x000E,	0x0145,	0x024C,	0x030E,	0x037F,	0x0399,	0x0360,	0x02E1
.hword 	0x022E,	0x015A,	0x007E,	0xFFB0,	0xFF00,	0xFE7D,	0xFE2E,	0xFE13,	0xFE2A
.hword 	0xFE69,	0xFEC3,	0xFF2A,	0xFF92,	0xFFEE,	0x0035,	0x0064,	0x0079,	0x0077
.hword 	0x0063,	0x0045,	0x0025,	0x0009,	0xFFF9,	0xFFF7,	0x0002,	0x001C,	0x003E
.hword 	0x0063,	0x0084,	0x009C,	0x00A5,	0x009D,	0x0083,	0x0057,	0x0020,	0xFFE2
.hword 	0xFFA3,	0xFF6A,	0xFF3F,	0xFF24,	0xFF1E,	0xFF2D,	0xFF4E,	0xFF7F,	0xFFBA
.hword 	0xFFF8,	0x0032,	0x0065,	0x008C,	0x00A2,	0x00A8,	0x009E

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 512

BPF_700HZDelay:
		.space BPF_700HZNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _BPF_700HZFilter

_BPF_700HZFilter:
.hword BPF_700HZNumTaps
.hword psvoffset(BPF_700HZTaps)
.hword psvoffset(BPF_700HZTaps)+BPF_700HZNumTaps*2-1
.hword psvpage(BPF_700HZTaps)
.hword BPF_700HZDelay
.hword BPF_700HZDelay+BPF_700HZNumTaps*2-1
.hword BPF_700HZDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_BPF_700HZFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_BPF_700HZFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_BPF_700HZFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
