; ..............................................................................
;    File   CW_1000.s
; ..............................................................................

		.equ CW_1000NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .CW_1000const, code
		.align 256

CW_1000Taps:
.hword 	0xFFE6,	0xFFE3,	0x0044,	0xFFD9,	0xFFDC,	0x0058,	0xFFCA,	0xFFD9,	0x0068
.hword 	0xFFBD,	0xFFD9,	0x0072,	0xFFB4,	0xFFDD,	0x0070,	0xFFB4,	0xFFE5,	0x0060
.hword 	0xFFBF,	0xFFF0,	0x003F,	0xFFDB,	0xFFFC,	0x000A,	0x000A,	0x0004,	0xFFC3
.hword 	0x0052,	0x0008,	0xFF69,	0x00B3,	0x0003,	0xFF01,	0x012D,	0xFFF2,	0xFE8E
.hword 	0x01BE,	0xFFD1,	0xFE17,	0x0261,	0xFF9E,	0xFDA3,	0x0311,	0xFF59,	0xFD3A
.hword 	0x03C5,	0xFF05,	0xFCE2,	0x0474,	0xFEA3,	0xFCA1,	0x0515,	0xFE38,	0xFC7B
.hword 	0x059D,	0xFDCC,	0xFC74,	0x0605,	0xFD63,	0xFC8A,	0x0646,	0xFD07,	0xFCBC
.hword 	0x065C,	0xFCBC,	0xFD07,	0x0646,	0xFC8A,	0xFD63,	0x0605,	0xFC74,	0xFDCC
.hword 	0x059D,	0xFC7B,	0xFE38,	0x0515,	0xFCA1,	0xFEA3,	0x0474,	0xFCE2,	0xFF05
.hword 	0x03C5,	0xFD3A,	0xFF59,	0x0311,	0xFDA3,	0xFF9E,	0x0261,	0xFE17,	0xFFD1
.hword 	0x01BE,	0xFE8E,	0xFFF2,	0x012D,	0xFF01,	0x0003,	0x00B3,	0xFF69,	0x0008
.hword 	0x0052,	0xFFC3,	0x0004,	0x000A,	0x000A,	0xFFFC,	0xFFDB,	0x003F,	0xFFF0
.hword 	0xFFBF,	0x0060,	0xFFE5,	0xFFB4,	0x0070,	0xFFDD,	0xFFB4,	0x0072,	0xFFD9
.hword 	0xFFBD,	0x0068,	0xFFD9,	0xFFCA,	0x0058,	0xFFDC,	0xFFD9,	0x0044,	0xFFE3
.hword 	0xFFE6

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

CW_1000Delay:
		.space CW_1000NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _CW_1000Filter

_CW_1000Filter:
.hword CW_1000NumTaps
.hword psvoffset(CW_1000Taps)
.hword psvoffset(CW_1000Taps)+CW_1000NumTaps*2-1
.hword psvpage(CW_1000Taps)
.hword CW_1000Delay
.hword CW_1000Delay+CW_1000NumTaps*2-1
.hword CW_1000Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_CW_1000Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_CW_1000Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_CW_1000Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
