; ..............................................................................
;    File   CW_400.s
; ..............................................................................

		.equ CW_400NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .CW_400const, code
		.align 256

CW_400Taps:
.hword 	0x0018,	0x001C,	0xFFC0,	0x0027,	0x0026,	0xFFA4,	0x003B,	0x002F,	0xFF84
.hword 	0x0055,	0x0036,	0xFF5F,	0x0075,	0x003C,	0xFF36,	0x009B,	0x003F,	0xFF0A
.hword 	0x00C7,	0x003E,	0xFEDD,	0x00F9,	0x0039,	0xFEAE,	0x0130,	0x002E,	0xFE80
.hword 	0x016B,	0x001E,	0xFE55,	0x01AA,	0x0008,	0xFE2C,	0x01EC,	0xFFEC,	0xFE09
.hword 	0x022E,	0xFFCA,	0xFDEB,	0x026F,	0xFFA2,	0xFDD5,	0x02AE,	0xFF76,	0xFDC6
.hword 	0x02E9,	0xFF46,	0xFDC0,	0x031E,	0xFF13,	0xFDC3,	0x034C,	0xFEDF,	0xFDCE
.hword 	0x0371,	0xFEAC,	0xFDE3,	0x038C,	0xFE7A,	0xFDFF,	0x039D,	0xFE4C,	0xFE23
.hword 	0x03A3,	0xFE23,	0xFE4C,	0x039D,	0xFDFF,	0xFE7A,	0x038C,	0xFDE3,	0xFEAC
.hword 	0x0371,	0xFDCE,	0xFEDF,	0x034C,	0xFDC3,	0xFF13,	0x031E,	0xFDC0,	0xFF46
.hword 	0x02E9,	0xFDC6,	0xFF76,	0x02AE,	0xFDD5,	0xFFA2,	0x026F,	0xFDEB,	0xFFCA
.hword 	0x022E,	0xFE09,	0xFFEC,	0x01EC,	0xFE2C,	0x0008,	0x01AA,	0xFE55,	0x001E
.hword 	0x016B,	0xFE80,	0x002E,	0x0130,	0xFEAE,	0x0039,	0x00F9,	0xFEDD,	0x003E
.hword 	0x00C7,	0xFF0A,	0x003F,	0x009B,	0xFF36,	0x003C,	0x0075,	0xFF5F,	0x0036
.hword 	0x0055,	0xFF84,	0x002F,	0x003B,	0xFFA4,	0x0026,	0x0027,	0xFFC0,	0x001C
.hword 	0x0018

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

CW_400Delay:
		.space CW_400NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _CW_400Filter

_CW_400Filter:
.hword CW_400NumTaps
.hword psvoffset(CW_400Taps)
.hword psvoffset(CW_400Taps)+CW_400NumTaps*2-1
.hword psvpage(CW_400Taps)
.hword CW_400Delay
.hword CW_400Delay+CW_400NumTaps*2-1
.hword CW_400Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_CW_400Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_CW_400Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_CW_400Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
