; ..............................................................................
;    File   CW_600.s
; ..............................................................................

		.equ CW_600NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .CW_600const, code
		.align 256

CW_600Taps:
.hword 	0xFFF9,	0xFFFB,	0x0009,	0xFFFE,	0x0000,	0xFFFD,	0x0006,	0x0007,	0xFFE7
.hword 	0x0015,	0x0010,	0xFFCB,	0x002C,	0x0019,	0xFFA6,	0x004B,	0x0020,	0xFF7A
.hword 	0x0073,	0x0025,	0xFF47,	0x00A5,	0x0027,	0xFF0E,	0x00E2,	0x0023,	0xFED1
.hword 	0x0128,	0x0018,	0xFE92,	0x0177,	0x0006,	0xFE54,	0x01CD,	0xFFEC,	0xFE18
.hword 	0x0228,	0xFFC9,	0xFDE1,	0x0285,	0xFF9C,	0xFDB3,	0x02E2,	0xFF69,	0xFD8E
.hword 	0x033B,	0xFF2E,	0xFD75,	0x038E,	0xFEEF,	0xFD69,	0x03D6,	0xFEAD,	0xFD6B
.hword 	0x0412,	0xFE6B,	0xFD7B,	0x043E,	0xFE2C,	0xFD97,	0x045A,	0xFDF2,	0xFDC0
.hword 	0x0463,	0xFDC0,	0xFDF2,	0x045A,	0xFD97,	0xFE2C,	0x043E,	0xFD7B,	0xFE6B
.hword 	0x0412,	0xFD6B,	0xFEAD,	0x03D6,	0xFD69,	0xFEEF,	0x038E,	0xFD75,	0xFF2E
.hword 	0x033B,	0xFD8E,	0xFF69,	0x02E2,	0xFDB3,	0xFF9C,	0x0285,	0xFDE1,	0xFFC9
.hword 	0x0228,	0xFE18,	0xFFEC,	0x01CD,	0xFE54,	0x0006,	0x0177,	0xFE92,	0x0018
.hword 	0x0128,	0xFED1,	0x0023,	0x00E2,	0xFF0E,	0x0027,	0x00A5,	0xFF47,	0x0025
.hword 	0x0073,	0xFF7A,	0x0020,	0x004B,	0xFFA6,	0x0019,	0x002C,	0xFFCB,	0x0010
.hword 	0x0015,	0xFFE7,	0x0007,	0x0006,	0xFFFD,	0x0000,	0xFFFE,	0x0009,	0xFFFB
.hword 	0xFFF9

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

CW_600Delay:
		.space CW_600NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _CW_600Filter

_CW_600Filter:
.hword CW_600NumTaps
.hword psvoffset(CW_600Taps)
.hword psvoffset(CW_600Taps)+CW_600NumTaps*2-1
.hword psvpage(CW_600Taps)
.hword CW_600Delay
.hword CW_600Delay+CW_600NumTaps*2-1
.hword CW_600Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_CW_600Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_CW_600Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_CW_600Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
