; ..............................................................................
;    File   CW_800.s
; ..............................................................................

		.equ CW_800NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .CW_800const, code
		.align 256

CW_800Taps:
.hword 	0xFFEA,	0xFFE8,	0x0035,	0xFFE3,	0xFFE7,	0x003B,	0xFFDF,	0xFFE9,	0x003A
.hword 	0xFFDE,	0xFFEE,	0x0031,	0xFFE4,	0xFFF5,	0x001D,	0xFFF3,	0xFFFF,	0xFFFD
.hword 	0x000D,	0x0007,	0xFFD0,	0x0036,	0x000F,	0xFF95,	0x0070,	0x0013,	0xFF4F
.hword 	0x00BA,	0x0010,	0xFEFE,	0x0116,	0x0005,	0xFEA7,	0x0182,	0xFFEF,	0xFE4C
.hword 	0x01FB,	0xFFCC,	0xFDF3,	0x027E,	0xFF9B,	0xFDA1,	0x0306,	0xFF5E,	0xFD59
.hword 	0x038E,	0xFF16,	0xFD21,	0x040F,	0xFEC5,	0xFCFB,	0x0484,	0xFE6E,	0xFCEA
.hword 	0x04E5,	0xFE16,	0xFCEF,	0x052F,	0xFDC2,	0xFD09,	0x055D,	0xFD76,	0xFD37
.hword 	0x056D,	0xFD37,	0xFD76,	0x055D,	0xFD09,	0xFDC2,	0x052F,	0xFCEF,	0xFE16
.hword 	0x04E5,	0xFCEA,	0xFE6E,	0x0484,	0xFCFB,	0xFEC5,	0x040F,	0xFD21,	0xFF16
.hword 	0x038E,	0xFD59,	0xFF5E,	0x0306,	0xFDA1,	0xFF9B,	0x027E,	0xFDF3,	0xFFCC
.hword 	0x01FB,	0xFE4C,	0xFFEF,	0x0182,	0xFEA7,	0x0005,	0x0116,	0xFEFE,	0x0010
.hword 	0x00BA,	0xFF4F,	0x0013,	0x0070,	0xFF95,	0x000F,	0x0036,	0xFFD0,	0x0007
.hword 	0x000D,	0xFFFD,	0xFFFF,	0xFFF3,	0x001D,	0xFFF5,	0xFFE4,	0x0031,	0xFFEE
.hword 	0xFFDE,	0x003A,	0xFFE9,	0xFFDF,	0x003B,	0xFFE7,	0xFFE3,	0x0035,	0xFFE8
.hword 	0xFFEA

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

CW_800Delay:
		.space CW_800NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _CW_800Filter

_CW_800Filter:
.hword CW_800NumTaps
.hword psvoffset(CW_800Taps)
.hword psvoffset(CW_800Taps)+CW_800NumTaps*2-1
.hword psvpage(CW_800Taps)
.hword CW_800Delay
.hword CW_800Delay+CW_800NumTaps*2-1
.hword CW_800Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_CW_800Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_CW_800Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_CW_800Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
