; ..............................................................................
;    File   LPF_3KHZ.s
; ..............................................................................

		.equ LPF_3KHZNumTaps, 17

; ..............................................................................
; Allocate and initialize filter taps

		.section .LPF_3KHZconst, code
		.align 64

LPF_3KHZTaps:
.hword 	0xFF9E,	0xFDEC,	0xFC62,	0xFCDA,	0x00FA,	0x08EE,	0x12BA,	0x1AE0,	0x1E0B
.hword 	0x1AE0,	0x12BA,	0x08EE,	0x00FA,	0xFCDA,	0xFC62,	0xFDEC,	0xFF9E

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 64

LPF_3KHZDelay:
		.space LPF_3KHZNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _LPF_3KHZFilter

_LPF_3KHZFilter:
.hword LPF_3KHZNumTaps
.hword psvoffset(LPF_3KHZTaps)
.hword psvoffset(LPF_3KHZTaps)+LPF_3KHZNumTaps*2-1
.hword psvpage(LPF_3KHZTaps)
.hword LPF_3KHZDelay
.hword LPF_3KHZDelay+LPF_3KHZNumTaps*2-1
.hword LPF_3KHZDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_LPF_3KHZFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_LPF_3KHZFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_LPF_3KHZFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
