#include <stdio.h>

#include "FIR_Filter.h"
#include "Lowpass_3_kHz.h"

#define NUM_SAMPLES 112
#define NUM_BLOCKS 10
#define NUM_SAMPLES_PER_BLOCK (NUM_SAMPLES-1)/NUM_BLOCKS+1

int main (int argc, char * argv[])
{
   FILE *pOutFile;
   int  inSamples[NUM_SAMPLES_PER_BLOCK], outSamples[NUM_SAMPLES_PER_BLOCK];
   int  i, j;


   pOutFile = fopen("Lowpass_3_kHz_impresponse.dat", "wt");
   if( pOutFile == NULL )
		abort();

   FIRDelayInit( &Lowpass_3_kHzFilter );

   inSamples[0] = 0x7FFF;
   FIR( 1, &outSamples[0], &inSamples[0], &Lowpass_3_kHzFilter );

   fprintf( pOutFile, "%g\n", outSamples[0]/32768. );

   for( i=0; i < NUM_SAMPLES_PER_BLOCK; i++ )
		inSamples[i] = 0;

   for( i=0; i < NUM_BLOCKS; i++ )
   {
   FIR( NUM_SAMPLES_PER_BLOCK, &outSamples[0], &inSamples[0], &Lowpass_3_kHzFilter );
		for( j=0; j < NUM_SAMPLES_PER_BLOCK; j++ )
			 fprintf( pOutFile, "%g\n", outSamples[j]/32768. );
   }

   fclose(pOutFile);
   return 0;
}

