; ..............................................................................
;    File   SSB_1800.s
; ..............................................................................

		.equ SSB_1800NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .SSB_1800const, code
		.align 256

SSB_1800Taps:
.hword 	0xFFFB,	0xFFFA,	0x0014,	0xFFF2,	0xFFF9,	0x001F,	0xFFE4,	0xFFFD,	0x0026
.hword 	0xFFD9,	0x0005,	0x0022,	0xFFDA,	0x000B,	0x0011,	0xFFF0,	0x0002,	0xFFFC
.hword 	0x001E,	0xFFDF,	0xFFED,	0x0060,	0xFF9B,	0xFFF7,	0x00A1,	0xFF3F,	0x0021
.hword 	0x00C8,	0xFEE7,	0x0067,	0x00C2,	0xFEB6,	0x00AB,	0x008A,	0xFED2,	0x00BC
.hword 	0x0039,	0xFF4F,	0x0067,	0x0002,	0x001C,	0xFF89,	0x0027,	0x010A,	0xFE1D
.hword 	0x00E4,	0x01C7,	0xFC51,	0x0251,	0x0200,	0xFA7B,	0x0457,	0x0176,	0xF908
.hword 	0x06A8,	0x001C,	0xF85A,	0x08D3,	0xFE22,	0xF8AA,	0x0A5D,	0xFBEA,	0xF9F1
.hword 	0x0AEC,	0xF9F1,	0xFBEA,	0x0A5D,	0xF8AA,	0xFE22,	0x08D3,	0xF85A,	0x001C
.hword 	0x06A8,	0xF908,	0x0176,	0x0457,	0xFA7B,	0x0200,	0x0251,	0xFC51,	0x01C7
.hword 	0x00E4,	0xFE1D,	0x010A,	0x0027,	0xFF89,	0x001C,	0x0002,	0x0067,	0xFF4F
.hword 	0x0039,	0x00BC,	0xFED2,	0x008A,	0x00AB,	0xFEB6,	0x00C2,	0x0067,	0xFEE7
.hword 	0x00C8,	0x0021,	0xFF3F,	0x00A1,	0xFFF7,	0xFF9B,	0x0060,	0xFFED,	0xFFDF
.hword 	0x001E,	0xFFFC,	0x0002,	0xFFF0,	0x0011,	0x000B,	0xFFDA,	0x0022,	0x0005
.hword 	0xFFD9,	0x0026,	0xFFFD,	0xFFE4,	0x001F,	0xFFF9,	0xFFF2,	0x0014,	0xFFFA
.hword 	0xFFFB

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

SSB_1800Delay:
		.space SSB_1800NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _SSB_1800Filter

_SSB_1800Filter:
.hword SSB_1800NumTaps
.hword psvoffset(SSB_1800Taps)
.hword psvoffset(SSB_1800Taps)+SSB_1800NumTaps*2-1
.hword psvpage(SSB_1800Taps)
.hword SSB_1800Delay
.hword SSB_1800Delay+SSB_1800NumTaps*2-1
.hword SSB_1800Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_SSB_1800Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_SSB_1800Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_SSB_1800Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
