; ..............................................................................
;    File   SSB_2000.s
; ..............................................................................

		.equ SSB_2000NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .SSB_2000const, code
		.align 256

SSB_2000Taps:
.hword 	0x0001,	0xFFFC,	0x0007,	0x0001,	0xFFF0,	0x0017,	0xFFFB,	0xFFE5,	0x002E
.hword 	0xFFEB,	0xFFE1,	0x0042,	0xFFD6,	0xFFEA,	0x0046,	0xFFCA,	0xFFFC,	0x0030
.hword 	0xFFDA,	0x0004,	0x0004,	0x0012,	0xFFEF,	0xFFD7,	0x0071,	0xFFA7,	0xFFC5
.hword 	0x00DA,	0xFF35,	0xFFE7,	0x0123,	0xFEBC,	0x003A,	0x0122,	0xFE78,	0x0096
.hword 	0x00CE,	0xFEA8,	0x00B0,	0x004F,	0xFF66,	0x0033,	0xFFFD,	0x0092,	0xFEEF
.hword 	0x003F,	0x01CE,	0xFCF2,	0x016C,	0x0292,	0xFAA0,	0x038E,	0x0262,	0xF894
.hword 	0x0654,	0x0106,	0xF772,	0x091F,	0xFEA7,	0xF7A8,	0x0B32,	0xFBCF,	0xF93F
.hword 	0x0BF7,	0xF93F,	0xFBCF,	0x0B32,	0xF7A8,	0xFEA7,	0x091F,	0xF772,	0x0106
.hword 	0x0654,	0xF894,	0x0262,	0x038E,	0xFAA0,	0x0292,	0x016C,	0xFCF2,	0x01CE
.hword 	0x003F,	0xFEEF,	0x0092,	0xFFFD,	0x0033,	0xFF66,	0x004F,	0x00B0,	0xFEA8
.hword 	0x00CE,	0x0096,	0xFE78,	0x0122,	0x003A,	0xFEBC,	0x0123,	0xFFE7,	0xFF35
.hword 	0x00DA,	0xFFC5,	0xFFA7,	0x0071,	0xFFD7,	0xFFEF,	0x0012,	0x0004,	0x0004
.hword 	0xFFDA,	0x0030,	0xFFFC,	0xFFCA,	0x0046,	0xFFEA,	0xFFD6,	0x0042,	0xFFE1
.hword 	0xFFEB,	0x002E,	0xFFE5,	0xFFFB,	0x0017,	0xFFF0,	0x0001,	0x0007,	0xFFFC
.hword 	0x0001

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

SSB_2000Delay:
		.space SSB_2000NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _SSB_2000Filter

_SSB_2000Filter:
.hword SSB_2000NumTaps
.hword psvoffset(SSB_2000Taps)
.hword psvoffset(SSB_2000Taps)+SSB_2000NumTaps*2-1
.hword psvpage(SSB_2000Taps)
.hword SSB_2000Delay
.hword SSB_2000Delay+SSB_2000NumTaps*2-1
.hword SSB_2000Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_SSB_2000Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_SSB_2000Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_SSB_2000Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
