; ..............................................................................
;    File   SSB_2200.s
; ..............................................................................

		.equ SSB_2200NumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .SSB_2200const, code
		.align 256

SSB_2200Taps:
.hword 	0xFFF9,	0x0009,	0xFFFF,	0xFFFC,	0x0005,	0x0000,	0x0002,	0xFFF5,	0x000E
.hword 	0x0006,	0xFFDB,	0x002E,	0xFFFC,	0xFFC6,	0x0055,	0xFFE0,	0xFFC5,	0x006D
.hword 	0xFFC0,	0xFFDE,	0x0060,	0xFFBD,	0xFFFD,	0x0025,	0xFFF5,	0xFFFC,	0xFFD6
.hword 	0x006D,	0xFFB7,	0xFFA1,	0x0104,	0xFF2A,	0xFFB9,	0x0172,	0xFE88,	0x0022
.hword 	0x0174,	0xFE31,	0x009E,	0x00F8,	0xFE86,	0x00B1,	0x0046,	0xFFA7,	0xFFDF
.hword 	0xFFF4,	0x0145,	0xFDEF,	0x00A2,	0x02B2,	0xFB2E,	0x02AE,	0x0318,	0xF865
.hword 	0x05E0,	0x01EA,	0xF696,	0x096A,	0xFF33,	0xF689,	0x0C30,	0xFBA8,	0xF869
.hword 	0x0D3D,	0xF869,	0xFBA8,	0x0C30,	0xF689,	0xFF33,	0x096A,	0xF696,	0x01EA
.hword 	0x05E0,	0xF865,	0x0318,	0x02AE,	0xFB2E,	0x02B2,	0x00A2,	0xFDEF,	0x0145
.hword 	0xFFF4,	0xFFDF,	0xFFA7,	0x0046,	0x00B1,	0xFE86,	0x00F8,	0x009E,	0xFE31
.hword 	0x0174,	0x0022,	0xFE88,	0x0172,	0xFFB9,	0xFF2A,	0x0104,	0xFFA1,	0xFFB7
.hword 	0x006D,	0xFFD6,	0xFFFC,	0xFFF5,	0x0025,	0xFFFD,	0xFFBD,	0x0060,	0xFFDE
.hword 	0xFFC0,	0x006D,	0xFFC5,	0xFFE0,	0x0055,	0xFFC6,	0xFFFC,	0x002E,	0xFFDB
.hword 	0x0006,	0x000E,	0xFFF5,	0x0002,	0x0000,	0x0005,	0xFFFC,	0xFFFF,	0x0009
.hword 	0xFFF9

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

SSB_2200Delay:
		.space SSB_2200NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _SSB_2200Filter

_SSB_2200Filter:
.hword SSB_2200NumTaps
.hword psvoffset(SSB_2200Taps)
.hword psvoffset(SSB_2200Taps)+SSB_2200NumTaps*2-1
.hword psvpage(SSB_2200Taps)
.hword SSB_2200Delay
.hword SSB_2200Delay+SSB_2200NumTaps*2-1
.hword SSB_2200Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_SSB_2200Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_SSB_2200Filter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_SSB_2200Filter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
