; ..............................................................................
;    File   SSB_2400T.s
; ..............................................................................

		.equ SSB_2400TNumTaps, 127

; ..............................................................................
; Allocate and initialize filter taps

		.section .SSB_2400Tconst, code
		.align 256

SSB_2400TTaps:
.hword 	0xFFED, 0x0007, 0x000E, 0xFFE9, 0x000E, 0x0006, 0xFFF3, 0x0006, 0x0000
.hword 	0x000A, 0xFFEA, 0x000C, 0x001F, 0xFFBC, 0x0032, 0x001E, 0xFF96, 0x0063
.hword 	0x0000, 0xFF94, 0x007F, 0xFFDA, 0xFFBC, 0x0063, 0xFFD5, 0xFFF2, 0x0009
.hword 	0x001A, 0x0000, 0xFF9A, 0x00AB, 0xFFB9, 0xFF5A, 0x014B, 0xFF25, 0xFF82
.hword 	0x019E, 0xFE95, 0x0000, 0x015F, 0xFE83, 0x006C, 0x00A4, 0xFF44, 0x002E
.hword 	0xFFF1, 0x00BE, 0xFED9, 0x0000, 0x0256, 0xFC82, 0x0163, 0x031F, 0xF9DE
.hword 	0x0414, 0x0262, 0xF7FE, 0x0759, 0x0000, 0xF7CA, 0x0A09, 0xFCA7, 0xF988
.hword 	0x0B12, 0xF988, 0xFCA7, 0x0A09, 0xF7CA, 0x0000, 0x0759, 0xF7FE, 0x0262
.hword 	0x0414, 0xF9DE, 0x031F, 0x0163, 0xFC82, 0x0256, 0x0000, 0xFED9, 0x00BE
.hword 	0xFFF1, 0x002E, 0xFF44, 0x00A4, 0x006C, 0xFE83, 0x015F, 0x0000, 0xFE95
.hword 	0x019E, 0xFF82, 0xFF25, 0x014B, 0xFF5A, 0xFFB9, 0x00AB, 0xFF9A, 0x0000
.hword 	0x001A, 0x0009, 0xFFF2, 0xFFD5, 0x0063, 0xFFBC, 0xFFDA, 0x007F, 0xFF94
.hword 	0x0000, 0x0063, 0xFF96, 0x001E, 0x0032, 0xFFBC, 0x001F, 0x000C, 0xFFEA
.hword 	0x000A, 0x0000, 0x0006, 0xFFF3, 0x0006, 0x000E, 0xFFE9, 0x000E, 0x0007
.hword 	0xFFED

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 256

SSB_2400TDelay:
		.space SSB_2400TNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _SSB_2400TFilter

_SSB_2400TFilter:
.hword SSB_2400TNumTaps
.hword psvoffset(SSB_2400TTaps)
.hword psvoffset(SSB_2400TTaps)+SSB_2400TNumTaps*2-1
.hword psvpage(SSB_2400TTaps)
.hword SSB_2400TDelay
.hword SSB_2400TDelay+SSB_2400TNumTaps*2-1
.hword SSB_2400TDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_SSB_2400TFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_SSB_2400TFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_SSB_2400TFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
