void WriteSI570(void);
void SlideSI570(void);
void I2C_SS (void);
void DDS_Write (unsigned int DDS_Data);
void LO2_Set(void);
void LO2_INIT(void);
int ABS(int);

void WriteSI570(void)
{
	unsigned char var, sid;
	SSP1ADD = 0x20;
	OpenI2C1(MASTER, SLEW_OFF);

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(137); 				//register addr
	IdleI2C();

	var = WriteI2C1(0x10); 				//assert freeze dco
	IdleI2C1();

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(0x07); 				//byte addr
	IdleI2C1();

	var = WriteI2C1(0xa3);
	IdleI2C1();

	if (Band == 0) sid = 0xc2;
	else sid = 0x42;
	var = WriteI2C1(sid);
	IdleI2C1();

	var = WriteI2C1(LO1.B4);
	IdleI2C1();

	var = WriteI2C1(LO1.B3);
	IdleI2C1();

	var = WriteI2C1(LO1.B2);
	IdleI2C1();

	var = WriteI2C1(LO1.B1);
	IdleI2C1();

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(137); 				//register addr
	IdleI2C1();

	var = WriteI2C1(0x00); 				//deassert freeze dco
	IdleI2C1();

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(135); 				//register addr
	IdleI2C1();

	var = WriteI2C1(0x40); 				//set new freq
	StopI2C1();

	CloseI2C1();	

}
void SlideSI570(void)
{
	unsigned char var, sid;

	OpenI2C1(MASTER, SLEW_OFF);

	SSP1ADD = 0x20;

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();
	var = WriteI2C1(135); 				//register addr
	IdleI2C();
	var = WriteI2C1(0x20); 				//assert freeze m

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(0x09); 				//byte addr
	IdleI2C1();

	var = WriteI2C1(LO1.B4);
	IdleI2C1();

	var = WriteI2C1(LO1.B3);
	IdleI2C1();

	var = WriteI2C1(LO1.B2);
	IdleI2C1();

	var = WriteI2C1(LO1.B1);
	IdleI2C1();

	I2C_SS();

	var = WriteI2C1(0xAA); 				//slave address
	IdleI2C1();

	var = WriteI2C1(135); 				//register addr
	IdleI2C1();

	var = WriteI2C1(0x00); 				//deassert freeze dco
	StopI2C1();

	CloseI2C1();	

}

void I2C_SS (void)
{
	StopI2C1()
	IdleI2C1();
	StartI2C1();
	IdleI2C1();
}
void LO2_Set(void)
{
unsigned char C = 0;

	if (Mode[Band][A_B[Band]] == 1) C = 1;
	if (Band == 2) C ^= 1;
	if (TX ==0) 
	{
		if (Mode[Band][A_B[Band]] == 1)
		{
			if (Parm_Data[0] < 0) LO2 = Base_LO2[C] + PBT_Freq;
			else LO2 = Base_LO2[C] - PBT_Freq;
		}
		else
		{
			if (Parm_Data[0] > 0) LO2 = Base_LO2[C] + PBT_Freq;
			else LO2 = Base_LO2[C] - PBT_Freq;
		}
	}
	else LO2 = Base_LO2[C];

//	DDS_Write(0x2100);
	DDS_Write(0x4000 + (LO2 & 0x3fff));
	DDS_Write(0x4000 + (LO2 >> 14));
//	DDS_Write(0xc000);
//	DDS_Write(0x2000);
}
int ABS(int i) 
{ 
if (i < 0) 
return -i; 
else 
return i; 
} 
void LO2_INIT(void)
{
	DDS_Write(0x2100);
	DDS_Write(0x77d3);
	DDS_Write(0x5b59);
	DDS_Write(0xc000);
	DDS_Write(0x2000);
}
void DDS_Write (unsigned int DDS_Data)
{
	unsigned int Test_Byte;
	unsigned char i;
	PORTBbits.RB2 = 1;
	PORTBbits.RB1 = 0;
	for (i=0; i<16; i++)
	{
		Test_Byte = DDS_Data & 0x8000;
		if (Test_Byte == 0) PORTBbits.RB3 = 0;
		else PORTBbits.RB3 = 1;
		Delay1TCY();
		Delay1TCY();
		PORTBbits.RB2 = 0;
		Delay1TCY();
		Delay1TCY();
		PORTBbits.RB2 = 1;
		DDS_Data <<= 1;
	}
	PORTBbits.RB1 = 1;
}
